@echo off
::
@set _ILA_Path=.\xco\chipscope_ila_%1.xco
@set _ICON_Path=.\xco\chipscope_icon_%1.xco
@set _CGP_Path=.\cgp\chipscope_%1.cgp
::
@if not exist %_ILA_Path%  goto switch_error
@if not exist %_ICON_Path% goto switch_error
@if not exist %_CGP_Path%  goto switch_error
::
@echo.
@echo Device Selected: %1
@echo.
@echo Project File: %_CGP_Path%
@echo ILA Parameters: %_ILA_Path%
@echo ICON Parameters: %_ICON_Path%
@echo.
::
::
@cd .\cgp
@if exist tmp    rmdir /q/s tmp
@if exist _bbx   rmdir /q/s _bbx
@if exist _xmsgs rmdir /q/s _xmsgs
@if exist chipscope_icon.constraints rmdir /q/s chipscope_icon.constraints
@if exist chipscope_ila.constraints  rmdir /q/s chipscope_ila.constraints
::
@if exist *.asy            del *.asy
@if exist *.constraints    del *.constraints
@if exist *.gise           del *.gise
@if exist *.vho            del *.vho
@if exist *ila.xco         del *ila.xco
@if exist *con.xco         del *con.xco
@if exist *.xise           del *.xise
@if exist *.txt            del *.txt
@if exist *.tcl            del *.tcl
@if exist *.cdc            del *.cdc
@if exist coregen.log      del coregen.log
@if exist *.cgc            del *.cgc
::
@if exist *.ngc           del *.ngc
@if exist *ila.vhd        del *ila.vhd
@if exist *con.vhd        del *con.vhd
@cd ..
::
@echo.
@echo Generating chipscope_ila files:
@echo.
@coregen -r -b %_ILA_Path%  -p %_CGP_Path%
@if errorlevel 1 goto coregen_error
@if exist coregen_ila.log del coregen_ila.log
@ren coregen.log coregen_ila.log
::
::
@cd .\cgp
@if exist tmp    rmdir /q/s tmp
@if exist _bbx   rmdir /q/s _bbx
@if exist _xmsgs rmdir /q/s _xmsgs
@if exist chipscope_icon.constraints rmdir /q/s chipscope_icon.constraints
@if exist chipscope_ila.constraints  rmdir /q/s chipscope_ila.constraints
::
@if exist *.asy            del *.asy
@if exist *.constraints    del *.constraints
@if exist *.gise           del *.gise
@if exist *.vho            del *.vho
@if exist *ila.xco         del *ila.xco
@if exist *icon.xco        del *icon.xco
@if exist *.xise           del *.xise
@if exist *.txt            del *.txt
@if exist *.tcl            del *.tcl
@if exist *.cdc            del *.cdc
@if exist coregen.log      del coregen.log
@if exist *.cgc            del *.cgc
@cd ..
::
::
@echo.
@echo Generating chipscope_icon files:
@echo.
@coregen -r -b %_ICON_Path% -p %_CGP_Path%
@if errorlevel 1 goto coregen_error
@if exist coregen_icon.log del coregen_icon.log
@ren coregen.log coregen_icon.log
::
::
@cd .\cgp
@if exist tmp    rmdir /q/s tmp
@if exist _bbx   rmdir /q/s _bbx
@if exist _xmsgs rmdir /q/s _xmsgs
@if exist chipscope_icon.constraints rmdir /q/s chipscope_icon.constraints
@if exist chipscope_ila.constraints  rmdir /q/s chipscope_ila.constraints
::
@if exist *.asy            del *.asy
@if exist *.constraints    del *.constraints
@if exist *.gise           del *.gise
@if exist *.vho            del *.vho
@if exist *ila.xco         del *ila.xco
@if exist *icon.xco        del *icon.xco
@if exist *.xise           del *.xise
@if exist *.txt            del *.txt
@if exist *.tcl            del *.tcl
@if exist *.cdc            del *.cdc
@if exist coregen.log      del coregen.log
@if exist *.cgc            del *.cgc
@cd ..
::
@echo.
@echo Generation of ChipScope cores complete.
@echo.
@exit /b 0
::
::
:switch_error
@echo.
@echo Batch file input error
@echo.
@echo Please enter a valid device type: 6vlx240t/6vlx365t/6vlx550t/6vsx315t/6vsx475t
@echo For example:
@echo.
@echo gen_chipscope.bat 6vlx240t
@echo.
@exit /b -1
::
::
:coregen_error
@echo.
@echo CORE Generator error detected
@exit /b %errorlevel%
