#!/bin/sh
#
echo ""
echo "Running gen_today_pkg.bash..."
echo ""
#

echo    "Date Format: dd:mm:YYYY"
echo -n "  Date Read: "
date +%d%m%Y
echo -n " Date Stamp: "
date +%d%m%Y
echo ""
#
echo    "Time Format: HH:MM:SS:00"
echo -n "  Time Read: "
date +%H%M%S
echo -n " Time Stamp: "
date +%H%M%S00
echo ""
#
#
# Generate VHDL package
#
OutFile="./common/today_pkg.vhd"
echo "Output File: $OutFile"
echo ""
#
echo "-- " > $OutFile
echo "-- today_pkg.vhd" >> $OutFile
echo "-- This file was generated automatically using the file gen_today_pkg.bash" >> $OutFile
echo "-- " >> $OutFile
echo "" >> $OutFile
#
echo "library ieee;" >> $OutFile
echo "use ieee.std_logic_1164.all;" >> $OutFile
echo "" >> $OutFile
#
echo "package today_pkg is" >> $OutFile
echo "" >> $OutFile
#
echo -n "  constant TODAYS_DATE : std_logic_vector(31 downto 0) := X\"" >> $OutFile
date +%d%m%Y\"\; >> $OutFile
echo -n "  constant TODAYS_TIME : std_logic_vector(31 downto 0) := X\"" >> $OutFile
date +%H%M%S00\"\; >> $OutFile
#
echo "" >> $OutFile
echo "end package today_pkg;" >> $OutFile
#
echo "Batch file complete"
echo ""