echo off
::
echo.
echo Running gen_today_pkg.bat...
echo.
::
:: Get short date format information from registry
For /F "TOKENS=2*" %%A In ('REG QUERY "HKCU\Control Panel\International" /v sShortDate') Do Set _sShortDate=%%B
Set _Date=00000000
:: UK settings
IF "%_sShortDate%"=="dd/MM/yyyy" Set _Date=%date:~0,2%%date:~3,2%%date:~6,4%
IF "%_sShortDate%"=="dd/MM/yy"   Set _Date=%date:~0,2%%date:~3,2%20%date:~6,2%
IF "%_sShortDate%"=="d/M/yy"     Set _Date=%date:~4,2%%date:~7,2%20%date:~10,2%
IF "%_sShortDate%"=="d.M.yy"     Set _Date=%date:~4,2%%date:~7,2%20%date:~10,2%
:: USA settings
IF "%_sShortDate%"=="M/d/yyyy"   Set _Date=%date:~7,2%%date:~4,2%%date:~10,4%
IF "%_sShortDate%"=="M/d/yy"     Set _Date=%date:~7,2%%date:~4,2%20%date:~10,2%
IF "%_sShortDate%"=="MM/dd/yy"   Set _Date=%date:~3,2%%date:~0,2%20%date:~6,2%
IF "%_sShortDate%"=="MM/dd/yyyy" Set _Date=%date:~3,2%%date:~0,2%%date:~6,4%
IF "%_sShortDate%"=="yy/MM/dd"   Set _Date=%date:~6,2%%date:~3,2%20%date:~0,2%
:: Common settings
IF "%_sShortDate%"=="yyyy-MM-dd" Set _Date=%date:~8,2%%date:~5,2%%date:~0,4%
::
:: Generate error message if unsupported format
IF "%_Date%"=="00000000" echo ERROR: Unsupported Date Format: %_sShortDate% = %date%
::
echo.
echo Date Format: %_sShortDate%
echo   Date Read: %date%
echo  Date Stamp: %_Date%
::
::
:: Get Hours and replace " " with 0 if present
set hh=%time:~0,2%
if "%time:~0,1%"==" " set hh=0%hh:~1,1%
::set _Time=%hh%%time:~3,2%%time:~6,2%%time:~9,2%
::
:: Get time format information and print to screen
For /F "TOKENS=2*" %%A In ('REG QUERY "HKCU\Control Panel\International" /v sTimeFormat') Do Set _sTimeFormat=%%B
Set _Time=00000000
:: Common settings
IF "%_sTimeFormat%"=="HH:mm:ss"    Set _Time=%hh%%time:~3,2%%time:~6,2%%time:~9,2%
IF "%_sTimeFormat%"=="H:mm:ss"     Set _Time=%hh%%time:~3,2%%time:~6,2%%time:~9,2%
IF "%_sTimeFormat%"=="hh:mm:ss tt" Set _Time=%hh%%time:~3,2%%time:~6,2%%time:~9,2%
IF "%_sTimeFormat%"=="h:mm:ss tt"  Set _Time=%hh%%time:~3,2%%time:~6,2%%time:~9,2%
::
:: Generate error message if unsupported format
IF "%_Time%"=="00000000" echo.
IF "%_Time%"=="00000000" echo ERROR: Unsupported Time Format: %_sTimeFormat% = %time%
::
echo.
echo Time Format: %_sTimeFormat%
echo   Time Read: %time%
echo  Time Stamp: %_Time%
::
echo.
IF "%_sTimeFormat%"=="hh:mm:ss tt" echo WARNING: Time stamp is in 12 hour time format
IF "%_sTimeFormat%"=="h:mm:ss tt"  echo WARNING: Time stamp is in 12 hour time format
::
::
:: Generate VHDL package
::
set _OutFile=.\common\today_pkg.vhd
echo Output File: %_OutFile%
echo.
::
echo -- > %_OutFile%
echo -- today_pkg.vhd >> %_OutFile%
echo -- This file was generated automatically using the file gen_today_pkg.bat>> %_OutFile%
echo -- >> %_OutFile%
echo. >> %_OutFile%
::
echo library ieee; >> %_OutFile%
echo use ieee.std_logic_1164.all; >> %_OutFile%
echo. >> %_OutFile%
::
echo package today_pkg is >> %_OutFile%
echo. >> %_OutFile%
::
echo   constant TODAYS_DATE : std_logic_vector(31 downto 0) := X"%_Date%"; >> %_OutFile%
echo   constant TODAYS_TIME : std_logic_vector(31 downto 0) := X"%_Time%"; >> %_OutFile%
::
echo. >> %_OutFile%
echo end package today_pkg; >> %_OutFile%
::
::
echo Batch file complete
echo.
echo on